/*
   This is a simple program that aborts a program that takes too long.
   The arguments are
   time in seconds program [ programs arguments ... ]

   Eventually, we'll probably accept arguments like "-e code" for the
   return code.  Currently, timeout returns 0 for success and 1 for failure
 */

#include <stdio.h>
#include <signal.h>

/* 
   This is a simple signal handler.  If we receive a SIGCLD (Child died), 
   we return success (child terminated before time-out reached).
 */
void handler()
{
exit( 0 );
}

main( argc, argv )
int  argc;
char **argv;
{
int  pid, i, secs;
char **nargv;

if (argc < 2) {
    fprintf( stderr, "%s - execute program with timeout\n" );
    return 1;
    }

#ifndef SIGCLD 
#define SIGCLD SIGCHLD
#endif

signal( SIGCLD, handler );
pid = fork( );
if (pid == -1) {
    fprintf( stderr, "Unable to fork new process\n" );
    return 1;
    }

if (pid == 0) {
    /* I'm the child */
    nargv = (char **) malloc( argc * sizeof(char *) );
    nargv[0] = argv[2];
    for (i=3; i<argc; i++) 
	nargv[i-2] = argv[i];
    nargv[argc-2] = (char *)0;
    execvp( argv[2], nargv );
    fprintf( stderr, "Could not exec %s\n", argv[0] );
    }
else {
    /* Start the timer */
    secs = atoi( argv[1] );
    sleep ( secs );
    /* If we got here, kill the child and return 0 as the status */
    signal( SIGCLD, SIG_IGN );
    kill( pid, SIGKILL );
    }
return 1;
}



